<?php
/******************************************************************************
* ManageTimeZones.php                                                         *
*******************************************************************************
* For SMF: Simple Machines Forum                                              *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           SMF 1.1.5+                                      *
* File Version:               1.0.3                                           *
* Software by:                DIN1031                                         *
* Copyright 2008 by:	     		DIN1031									                        *
* Support, News, Updates at:  http://mods.simplemachines.org                  *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by SMF.                *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
******************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

function ManageTimezones() {
	global $context, $txt, $scripturl, $modSettings;

	isAllowedTo('admin_forum');

	// Administrative side bar, here we come!
	adminIndex('manage_timezones');

	// Little short on the ground of functions here... but things can and maybe will change...
	$subActions = array(
		'settings' => 'timezone_settings',
		'search' => 'timezone_search',
		'info' => 'timezone_info',
		'disableAll' => 'timezone_disableAll',
		'enableAll' => 'timezone_enableAll',
		'edit' => 'timezone_edit',
	);

	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'info';

	// Set up the two tabs here...
	$context['admin_tabs'] = array(
		'title' => &$txt['manage_timezones'],
		'help' => 'timezones',
		'description' => $txt['timezones_desc'],
		'tabs' => array(
			'info' => array(
				'title' => $txt['timezones_info'],
				'description' => $txt['timezones_info_desc'],
				'href' => $scripturl . '?action=managetimezones;sa=info',
			),
			'settings' => array(
				'title' => $txt['timezones_settings'],
				'description' => $txt['timezones_settings_desc'],
				'href' => $scripturl . '?action=managetimezones;sa=settings',
			),
			'search' => array(
				'title' => $txt['timezones_search_short'],
				'description' => $txt['timezones_search_desc'],
				'href' => $scripturl . '?action=managetimezones;sa=search',
			),
		),
	);

	//This is for all the Worldpart Timezones Settings ;)
	load_masterZones();
	foreach($context['timezones']['master'] as $item)
	{
		$text = isset($txt['timezones_'.$item]) ? $txt['timezones_'.$item] : $item;
		$context['admin_tabs']['tabs'][$item] =  array(
				'title' => $text,
				'description' => $txt['timezones_search_desc'],
				'href' => $scripturl . '?action=managetimezones;sa=search;master='.$item,
			);
	}
	if(!isset($_REQUEST['master']) || !in_array($_REQUEST['master'], $context['timezones']['master']))
		$_REQUEST['master'] = '';

	// Select the tab they're at...
	if($_REQUEST['sa'] != 'edit')
	{
		if(isset($context['admin_tabs']['tabs'][$_REQUEST['master']]))
			$context['admin_tabs']['tabs'][$_REQUEST['master']]['is_selected'] = true;
		elseif (isset($context['admin_tabs']['tabs'][$_REQUEST['sa']]))
			$context['admin_tabs']['tabs'][$_REQUEST['sa']]['is_selected'] = true;
	}
	//Page Name
	$context['page_title'] = $txt['manage_timezones'];

	$subActions[$_REQUEST['sa']]();
}

function timezone_edit()
{
	global $modSettings, $sourcedir, $txt, $scripturl, $context, $settings, $sc, $func, $db_prefix;

	//Prepare the master zone ;)
	$_REQUEST['master'] = explode('/', $_REQUEST['zone']);
	$_REQUEST['master'] = current($_REQUEST['master']);

	$return_possility = array(
		'search' => 'action=managetimezones;sa=search;search='.$_REQUEST['zone'],
		'master' => 'action=managetimezones;sa=search;master='.$_REQUEST['master'],
	);

	//Setup return page
	$context['returnTo'] = isset($_REQUEST['return']) && isset($return_possility[$_REQUEST['return']]) ? $_REQUEST['return'] : 'search';

	if(isset($_GET['save']))
	{
		//Prepare the Datas for the Database 8)
		$sql = array();
		$sql[] = "replacename = '" . $func['htmlspecialchars'](stripslashes($_REQUEST['replaceName']), ENT_QUOTES) . "'";
		$sql[] = "short_zone = '" . $func['htmlspecialchars'](stripslashes($_REQUEST['short_zone']), ENT_QUOTES) . "'";
		$sql[] = "country_name = '" . $func['htmlspecialchars'](stripslashes($_REQUEST['country_name']), ENT_QUOTES) . "'";
		$sql[] = "comment = '" . $func['htmlspecialchars'](stripslashes($_REQUEST['comment']), ENT_QUOTES) . "'";
		//Masterzone can not disabled!
		if(empty($modSettings['timezones_standard']) || $modSettings['timezones_standard'] != $_REQUEST['zone'])
			$sql[] = "disabled = ".(!empty($_REQUEST['disabled']) ? 1 : 0);

		db_query("
			UPDATE {$db_prefix}timezone
			SET ".implode(", ", $sql)."
			WHERE zone = '$_REQUEST[zone]'
			LIMIT 1", __FILE__, __LINE__);

		//Return
		redirectexit($return_possility[$context['returnTo']]);
	}

	//Load the data 8)
	loadTimeZones($_REQUEST['zone'], false);
	if(!isset($context['timezones']['TZ'][$_REQUEST['zone']]))
		redirectexit($return_possility[$context['returnTo']]);
	$context['zone'] = $context['timezones']['TZ'][$_REQUEST['zone']];

	//Templatedatas
	loadTemplate('ManageTimezones');
	$context['page_title'] = $txt['timezones_edit'];
	$context['sub_template'] = 'timezones_edit';
	$context['post_url'] = $scripturl.'?action=managetimezones;sa=edit;save';
}

function timezone_disableAll()
{
	global $db_prefix, $modSettings;

	if(empty($_REQUEST['master']))
		redirectexit('action=managetimezones;sa=search');

	//Disable all... from this zone ;)
	$result = searchTimezones($_REQUEST['master'], 'master', false); //Only the not allready ignored 8)

	if(!empty($modSettings['timezones_standard']) && isset($result[$modSettings['timezones_standard']]))
		unset($result[$modSettings['timezones_standard']]);

	if(empty($result))
		redirectexit('action=managetimezones;sa=search;master='.$_REQUEST['master']);

	//First Disable all 8)
	db_query("
		UPDATE {$db_prefix}timezone
		SET disabled = 1
		WHERE zone IN ('".implode("', '", $result)."')", __FILE__, __LINE__);

	//Now remove all entries from the members :x
	db_query("
		UPDATE {$db_prefix}members
		SET timezone = '', timezone_update = 0, timezone_offset = 0
		WHERE timezone IN ('".implode("', '", $result)."')", __FILE__, __LINE__);

	//Okay all done back to the masterzone 8)
	redirectexit('action=managetimezones;sa=search;master='.$_REQUEST['master']);
}

function timezone_enableAll()
{
	global $db_prefix;

	if(empty($_REQUEST['master']))
		redirectexit('action=managetimezones;sa=search');

	//Disable all... from this zone ;)
	$result = searchTimezones($_REQUEST['master'], 'master', false, false);

	if(empty($result))
		redirectexit('action=managetimezones;sa=search;master='.$_REQUEST['master']);

	//First Disable all 8)
	db_query("
		UPDATE {$db_prefix}timezone
		SET disabled = 0
		WHERE zone IN ('".implode("', '", $result)."')", __FILE__, __LINE__);

	//Okay all done back to the masterzone 8)
	redirectexit('action=managetimezones;sa=search;master='.$_REQUEST['master']);
}

function timezone_settings()
{
	global $modSettings, $sourcedir, $txt, $scripturl, $context, $settings, $sc;

	loadLanguage('Help');
	loadLanguage('ModSettings');

	// Will need the utility functions from here.
	require_once($sourcedir . '/ManageServer.php');

	$context['page_title'] = $txt['manage_timezones'];
	$context['sub_template'] = 'show_settings';

	//Load Timezone Datas :D
	loadTimeZones(true);
	$timezonearray = array('0' => $txt['timezones_nothing']); //Nothing Selected ;)
	foreach($context['timezones']['TZ'] as $zone)
		$timezonearray2[$zone['zone']] = return_selectField($zone);
	asort($timezonearray2);
	$timezonearray += $timezonearray2;

	$searchTimeZone = '<a href="'.$scripturl.'?action=managetimezones;sa=search;return=settings">'.$txt['timezones_search'].'</a>';

	//Replace the zone after a serach :)
	if(isset($_REQUEST['zone']))
		$modSettings['timezones_standard'] = $_REQUEST['zone'];

	$config_vars = array(
			// Time Zone Basic Setting?
			array('float', 'time_offset'),
			array('check', 'timezones_enable'),
		'',
			// Standard Time Zone.
			array('check', 'timezones_useStandard'),
			array('text', 'timezones_selectField', 80),
			array('select', 'timezones_standard', $timezonearray),
		$searchTimeZone,
		'',
			//Normal not needed fix... only for misconfigured servers...
			array('int', 'timezones_utcFix'),
			array('check', 'timezones_dtsFix'),
		'',
			// Register Settings?
			//array('check', 'timezones_enableRegister'),
			//array('check', 'timezones_tryDetectZone'),
	);

	// Saving?
	if (isset($_GET['save']))
	{
		saveDBSettings($config_vars);
		update_standardTimeZone();
		redirectexit('action=managetimezones;sa=settings');
	}

	$context['post_url'] = $scripturl . '?action=managetimezones;sa=settings;save';
	$context['settings_title'] = $txt['timezones_settings'];

	prepareDBSettingContext($config_vars);
}

function timezone_info()
{
	global $modSettings, $sourcedir, $txt, $scripturl, $context, $settings, $sc;

	loadTemplate('ManageTimezones');

	//Prepare some datas :)
	$time = time();
	$time_format = "F j, Y H:i:s";
	$context['info']['server_time'] = date($time_format, $time);
	$context['info']['utc_time'] = date($time_format, utcTimestamp($time));

	$context['info']['smf_time'] = date($time_format, forum_time(false, $time));

	$txt['timezones_information_about'] = str_replace('%yearVersion', '2008', $txt['timezones_information_about']);

	if(!empty($modSettings['timezones_enable']) && !empty($modSettings['timezones_standard']))
	{
		$context['info']['smf_clactime'] = date($time_format, zoneTimestamp($time, $modSettings['timezones_standard']));;
		$context['info']['smf_zone'] = $modSettings['timezones_standard'];
		$context['info']['smf_dts'] = !empty($modSettings['timezones_standard_update']) ? date($time_format, $modSettings['timezones_standard_update']).' UTC' : $txt['timezones_DST_NoUpdate'];
	}
	else
	{
		$context['info']['smf_clactime'] = $context['info']['smf_time'];
		$context['info']['smf_zone'] = $txt['timezones_unkown'];
		$context['info']['smf_dts'] = $txt['timezones_unkown'];
	}

}

function timezone_search()
{
	global $modSettings, $sourcedir, $txt, $scripturl, $context, $settings, $sc, $func;

	//Only for Members :)
	if(!$context['user']['is_logged'])
		redirectexit();

	loadTemplate('ManageTimezones');
	$context['page_title'] = $txt['timezones_search'];
	$context['sub_template'] = 'timezones_list';
	$context['showSearch'] = !empty($_REQUEST['master']) ? 0 : 1;

	if($context['current_action'] == 'managetimezones' && $context['user']['is_admin'])
		$context['post_url'] = $scripturl.'?action=managetimezones;sa=search';
	else
		$context['post_url'] = $scripturl.'?action=timezonesearch';

	//Check the valid Return Option
	$context['href_link'] = '';
	$context['return'] = '';
	if(!empty($_REQUEST['return']))
	{
		$return = array(
			'profil' => $scripturl.'?action=profile;sa=theme;zone=',
		);
		if($context['user']['is_admin'])
			$return += array(
				'settings' => $scripturl.'?action=managetimezones;sa=settings;zone=',
			);

		if(!isset($return[$_REQUEST['return']]))
			unset($_REQUEST['return']);
		else
		{
			$context['href_link'] = $return[$_REQUEST['return']];
			$context['return'] = $_REQUEST['return'];
		}
	}

	if(!empty($_REQUEST['master']))
	{
		$text = isset($txt['timezones_'.$_REQUEST['master']]) ? $txt['timezones_'.$_REQUEST['master']] : $_REQUEST['master'];
		$context['page_title'] = $txt['timezones_show_worldpart'].' '.$text;
		$_REQUEST['search'] = $func['htmlspecialchars']($_REQUEST['master'], ENT_QUOTES);
		$_POST['includeDisabled'] = $context['user']['is_admin'] ? 1 : 0;
		$context['show_masterDisable'] = $context['user']['is_admin']; //Only Admin should see a Disable all *g*
	}
	else
		$context['show_masterDisable'] = false;

	$context['timezones_searches'] = array();
	if(!empty($_REQUEST['search']))
	{
		$ignore = !(!empty($_POST['includeDisabled']) && $context['user']['is_admin']);

		if(empty($_REQUEST['master']))
			$_REQUEST['search'] = '%'.$_REQUEST['search'].'%';

		//Search for it :D
		$result = searchTimezones($_REQUEST['search'], !empty($_REQUEST['master']) ? 'master' : 'all', false, $ignore);
		if(!empty($result))
		{
			loadTimeZones($result, $ignore);
			$context['some_enabled'] = false;
			foreach($result as $zone)
			{
				$info = $context['timezones']['TZ'][$zone];
				$context['timezones_searches'][$zone] = array(
					'name' => !empty($context['href_link']) ? '<a href="'.$context['href_link'].$zone.'">'.$info['replaceName'].'</a>' : $info['replaceName'],
					'worldpart' => $info['master_zone'],
					'city_land' => $info['sub_zone'],
					'country_name' => $info['country_name'],
					'country_code' => $info['iso_code'],
					'designator' => $info['short_zone'],
					'offset' => $info['utc'],
					'dst' => !empty($info['dts']) ? $txt['timezones_dst_yes'] : $txt['timezones_dst_no'],
					'edit' => '',
					'enabled' => true,
				);
				if($context['user']['is_admin'])
				{
					$context['timezones_searches'][$zone]['edit'] = '<a href="'.$scripturl.'?action=managetimezones;sa=edit;zone='.$zone.(!empty($_REQUEST['master']) ? ';return=master' : '').'">Edit</a>';
					$context['timezones_searches'][$zone]['enabled'] = empty($info['disabled']);
					//Find Out if all Disabled *g*
					if(!$context['some_enabled'])
					{
						if(empty($modSettings['timezones_standard']) || $zone != $modSettings['timezones_standard'])
							$context['some_enabled'] = empty($info['disabled']);
					}
				}
			}
		}
	}
}
?>