<id>
din1031:TimezoneSelect
</id>

<version>
1.1.0
</version>

<edit file>
$sourcedir/Subs-TimeZone.php
</edit file>

<search for>
function local_userTime($memID)
{
		global $modSettings, $user_info, $user_profile;

		//Current local time calculation 8)
		$time = time();

		if(!isset($user_profile[$memID]) && !empty($memID))
			loadMemberData($memID);

		//The user don't use any timezone, so it's the forumstandard 8)
		if(empty($memID) || empty($user_profile[$memID]['timezone']))
			return timeformat($time, false);

		if(!empty($user_profile[$memID]['timezone_update']) && $user_profile[$memID]['timezone_update'] < utcTimestamp())
			update_memberTimeZone($memID, $user_profile[$memID]['timezone']);

		return timeformat($time + ($user_profile[$memID]['timezone_offset'] - $user_info['timezone_offset']), false);
}
</search for>

<replace>
function local_userTime($memID)
{
		global $modSettings, $user_info, $user_profile, $ID_MEMBER;

		if(!isset($user_profile[$memID]) && !empty($memID))
			loadMemberData($memID);

		//Current local time calculation 8)
		$time = time();
		
		// Prepare the timezone
		$timezone = '%Z';
		if(strpos($user_info['time_format'], '%Z') !== false)
		{
			$zone = (!empty($user_profile[$memID]['timezone']) ? $user_profile[$memID]['timezone'] : (!empty($modSettings['timezones_useStandard']) ? $modSettings['timezones_standard'] : ''));
			$offset = (!empty($user_profile[$memID]['timezone']) ? $user_profile[$memID]['timezone_offset'] : (!empty($modSettings['timezones_useStandard']) ? $modSettings['timezones_standard_offset'] : 0));
			$timezone = return_shortTimezone($zone, $offset);
		}

		// Okay if not timezone_offset is set take standard :P
		$offset = (!empty($user_info['timezone']) ? $user_info['timezone_offset'] : (!empty($modSettings['timezones_useStandard']) ? $modSettings['timezones_standard_offset'] : 0));		

		//The user don't use any timezone, so it's the forumstandard 8)
		if(empty($memID) || empty($user_profile[$memID]['timezone']))
		{
			$standardOffset = !empty($modSettings['timezones_useStandard']) ? $modSettings['timezones_standard_offset'] : 0;
			$calculated = empty($modSettings['timezones_useStandard']) ? utcTimestamp() : time() + ($modSettings['timezones_standard_offset'] - $offset);
			return timeformat($calculated, false, $timezone);
		}

		if(!empty($user_profile[$memID]['timezone_update']) && $user_profile[$memID]['timezone_update'] < utcTimestamp())
			update_memberTimeZone($memID, $user_profile[$memID]['timezone']);
		
		return timeformat($time + ($user_profile[$memID]['timezone_offset'] - $offset), false, $timezone);
}
</replace>

<search for>
function return_selectField($tz_data)
</search for>

<replace>
function return_shortTimezone($zone = '', $currentOffset = 0)
{
	static $shortzone = array();

	// Return standard on nothing :P
	if (empty($zone))
		return '%Z';
	elseif (!empty($shortzone[$zone]))
		return $shortzone[$zone];
	
	// Okay do some work :)
	global $context, $db_prefix;

	$szone = array(
		'short_zone' => '%Z',
		'dts' => 0,
		'seconds' => 0,
	);
	if (!empty($context['timezones']['TZ'][$zone]))
		$szone = array(
			'short_zone' => $context['timezones']['TZ'][$zone]['short_zone'],
			'dts' => $context['timezones']['TZ'][$zone]['dts'],
			'seconds' => $context['timezones']['TZ'][$zone]['seconds'],
		);
	else
	{
		// Okay take the short zone and the time :D
		$request = db_query("
			SELECT short_zone, dts, seconds
			FROM {$db_prefix}timezone
			WHERE zone = '$zone'
			LIMIT 1", __FILE__, __LINE__);
		$data = mysql_fetch_assoc($request);
		mysql_free_result($request);
		if (!empty($data))
			$szone = $data;
	}
	
	// Let's see if there is a dts zone this is a special case :D
	if (empty($szone['dts']))
		$shortzone[$zone] = $szone['short_zone'];
	else
	{
		$szone['short_zone'] = explode('/', $szone['short_zone']);
		// Okay sorry i can't detect it...
		if (count($szone['short_zone']) > 2)
			$shortzone[$zone] = implode('/', $szone['short_zone']);
		// Okay no diffrence?
		elseif (count($szone['short_zone']) == 1 || $szone['short_zone'][0] == $szone['short_zone'][1])
			$shortzone[$zone] = current($szone['short_zone']);
		// The current Timezone of the user can help me :D
		elseif (!empty($currentOffset))
		{
			if ($currentOffset == $szone['seconds'])
				$shortzone[$zone] = $szone['short_zone'][1];
			else
				$shortzone[$zone] = $szone['short_zone'][0];
		}
		// The hard way... load the complete timezone data... with this i can exact say
		else
		{
			$dts = calculateZoneDtsData($zone);
			if ($dts['offsetSeconds'] == $szone['seconds'])
				$shortzone[$zone] = $szone['short_zone'][1];
			else
				$shortzone[$zone] = $szone['short_zone'][0];
		}
	}
	return $shortzone[$zone];
}

function return_selectField($tz_data)
</replace>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
function timeformat($logTime, $show_today = true)
</search for>

<replace>
function timeformat($logTime, $show_today = true, $timezone = false)
</replace>

<search for>
	// Format any other characters..
	return strftime($str, $time);
</search for>

<replace>
	// Okay add the correct Timezone short cut for %Z
	if (!empty($modSettings['timezones_enable']) && strpos($user_info['time_format'], '%Z') !== false)
	{
		if ($timezone === false)
		{
			if (empty($user_info['timezone_shortcut']))
			{
				$zone = (!empty($user_info['timezone']) ? $user_info['timezone'] : (!empty($modSettings['timezones_useStandard']) ? $modSettings['timezones_standard'] : ''));
				$offset = (!empty($user_info['timezone']) ? $user_info['timezone_offset'] : (!empty($modSettings['timezones_useStandard']) ? $modSettings['timezones_standard_offset'] : 0));
				$user_info['timezone_shortcut'] = return_shortTimezone($zone, $offset);
			}
			$str = str_replace('%Z', $user_info['timezone_shortcut'], $str);
		}
		else
				$str = str_replace('%Z', $timezone, $str);
	}

	// Format any other characters..
	return strftime($str, $time);
</replace>

